import { ServiceRouterCardwallInterface } from '../interface/service_router_cardwall.interface'
import { Component, OnInit, Inject, Output, EventEmitter } from '@angular/core';
import { Router } from '@angular/router';
import { DragulaService } from 'ng2-dragula/ng2-dragula';
import { CardwallComponent } from './cardwall.component';

@Component({
  selector: 'service-router-cardwall',
  templateUrl: './service_router_cardwall.component.html',
  styleUrls: ['./service_router_cardwall.component.css']
})
export class ServiceRouterCardwallComponent extends CardwallComponent {
  public service_router_cardwall_data : Array<any> = [];
  @Output() card_click_event = new EventEmitter();

  constructor(
    private service_router: Router,
    private service_dragulaService: DragulaService,
  	@Inject('ServiceRouterCardwallInterface') private service_router_cardwall_interface: ServiceRouterCardwallInterface
  ) { 
    super(service_router,
      service_dragulaService,
      service_router_cardwall_interface);
    for (let container of this.getCardwallData()) {
      if (this.isVisible(container.name)) {
        this.service_router_cardwall_data.push(container);
      }
    }      
  }

  isVisible(cardwall_name) {
    switch(cardwall_name) {
      case 'predispatch':
        return this.service_router_cardwall_interface.canPredispatchTicket();
      case 'dispatch':
        return this.service_router_cardwall_interface.canDispatchTicket();
      case 'parts_request':
        return this.service_router_cardwall_interface.canPriceParts();
      case 'class_a':
        return this.service_router_cardwall_interface.canReassignTechnician();
      case 'class_b':
        return this.service_router_cardwall_interface.canReassignTechnician();
      case 'class_c':
        return this.service_router_cardwall_interface.canReassignTechnician();
      case 'technician_queue':
        return this.service_router_cardwall_interface.canViewTechnicianQueue();
      case 'inspection_queue':
        return this.service_router_cardwall_interface.canViewInspections();
      case 'in_progress_queue':
        return this.service_router_cardwall_interface.canViewServiceTicketJobsInProcess();
      case 'additional_approvals':
        return this.service_router_cardwall_interface.canHandleApprovals();
      case 'completed_queue':
        return this.service_router_cardwall_interface.canViewServiceTicketComplete();
      case 'invoice':
        return this.service_router_cardwall_interface.canHandleInvoice();
      case 'closed_queue':
        return this.service_router_cardwall_interface.canViewClose();
      default:
        return false;
    }
  }

  getServiceRouterCardwallData() {
    return this.service_router_cardwall_data;
  }

  __click_card(card_data, status) {
    this.card_click_event.emit(card_data)
  }
}
