/**
 * FutureDMS API
 * Premier Enterprise Dealership Management System
 *
 * OpenAPI spec version: 0.7.8
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class BDCApi {
    protected basePath = 'https://api.futuredms.com/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdAuditReportGet(customerId: string, extraHttpRequestParams?: any): Observable<models.InsOtherReport> {
        return this.customerCustomerIdAuditReportGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the association between a customer and a contact
     */
    public customerCustomerIdContactsContactIdDelete(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdContactsContactIdDeleteWithHttpInfo(customerId, contactId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the contactId
     */
    public customerCustomerIdContactsContactIdGet(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<models.CustomerContact> {
        return this.customerCustomerIdContactsContactIdGetWithHttpInfo(customerId, contactId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the association between a contact and a customer
     */
    public customerCustomerIdContactsContactIdPut(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdContactsContactIdPutWithHttpInfo(customerId, contactId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of
     */
    public customerCustomerIdContactsGet(customerId: string, extraHttpRequestParams?: any): Observable<Array<models.CustomerContact>> {
        return this.customerCustomerIdContactsGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdEquityReportGet(customerId: string, extraHttpRequestParams?: any): Observable<models.EquityReport> {
        return this.customerCustomerIdEquityReportGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdInsOtherReportGet(customerId: string, extraHttpRequestParams?: any): Observable<models.InsOtherReport> {
        return this.customerCustomerIdInsOtherReportGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdLifetimeValueReportGet(customerId: string, extraHttpRequestParams?: any): Observable<models.LifeTimeValueReport> {
        return this.customerCustomerIdLifetimeValueReportGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of
     */
    public customerCustomerIdRelationshipsGet(customerId: string, extraHttpRequestParams?: any): Observable<Array<models.CustomerRelationship>> {
        return this.customerCustomerIdRelationshipsGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdDelete(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdRelationshipsRelationshipIdDeleteWithHttpInfo(customerId, relationshipId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdGet(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<models.CustomerRelationship> {
        return this.customerCustomerIdRelationshipsRelationshipIdGetWithHttpInfo(customerId, relationshipId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdPut(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdRelationshipsRelationshipIdPutWithHttpInfo(customerId, relationshipId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign email event
     */
    public emailEventEventIdDelete(eventId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.emailEventEventIdDeleteWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId the id of the campaign email event
     */
    public emailEventEventIdGet(eventId: string, extraHttpRequestParams?: any): Observable<models.CampaignEmailEvent> {
        return this.emailEventEventIdGetWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign email event
     */
    public emailEventEventIdPut(eventId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.emailEventEventIdPutWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     */
    public emailEventGet(extraHttpRequestParams?: any): Observable<Array<models.CampaignEmailEvent>> {
        return this.emailEventGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     */
    public emailTemplatesGet(extraHttpRequestParams?: any): Observable<Array<models.EmailTemplate>> {
        return this.emailTemplatesGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param templateId The id of the template
     */
    public emailTemplatesTemplateIdDelete(templateId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.emailTemplatesTemplateIdDeleteWithHttpInfo(templateId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param templateId The id of the email template
     */
    public emailTemplatesTemplateIdGet(templateId: string, extraHttpRequestParams?: any): Observable<models.EmailTemplate> {
        return this.emailTemplatesTemplateIdGetWithHttpInfo(templateId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param templateId The id of the template
     * @param template 
     */
    public emailTemplatesTemplateIdPut(templateId: string, template: models.EmailTemplate, extraHttpRequestParams?: any): Observable<{}> {
        return this.emailTemplatesTemplateIdPutWithHttpInfo(templateId, template, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     */
    public eventGet(extraHttpRequestParams?: any): Observable<Array<models.CampaignEvent>> {
        return this.eventGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     */
    public phoneCallEventGet(extraHttpRequestParams?: any): Observable<Array<models.PhoneCallEvent>> {
        return this.phoneCallEventGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdDelete(phoneCallId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.phoneCallEventPhoneCallIdDeleteWithHttpInfo(phoneCallId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdGet(phoneCallId: string, extraHttpRequestParams?: any): Observable<models.PhoneCallEvent> {
        return this.phoneCallEventPhoneCallIdGetWithHttpInfo(phoneCallId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdNotesDelete(phoneCallId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.phoneCallEventPhoneCallIdNotesDeleteWithHttpInfo(phoneCallId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdNotesGet(phoneCallId: string, extraHttpRequestParams?: any): Observable<Array<models.PhoneCallNotes>> {
        return this.phoneCallEventPhoneCallIdNotesGetWithHttpInfo(phoneCallId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     * @param phoneCallNotes 
     */
    public phoneCallEventPhoneCallIdNotesPut(phoneCallId: string, phoneCallNotes: models.PhoneCallNotes, extraHttpRequestParams?: any): Observable<{}> {
        return this.phoneCallEventPhoneCallIdNotesPutWithHttpInfo(phoneCallId, phoneCallNotes, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdPut(phoneCallId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.phoneCallEventPhoneCallIdPutWithHttpInfo(phoneCallId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the sales appointment event
     */
    public salesAppointmentEventEventIdGet(eventId: string, extraHttpRequestParams?: any): Observable<models.SalesAppointmentEvent> {
        return this.salesAppointmentEventEventIdGetWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdDelete(eventId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.smsEventEventIdDeleteWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdGet(eventId: string, extraHttpRequestParams?: any): Observable<models.CampaignSMSEvent> {
        return this.smsEventEventIdGetWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdPut(eventId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.smsEventEventIdPutWithHttpInfo(eventId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     */
    public smsEventGet(extraHttpRequestParams?: any): Observable<Array<models.CampaignSMSEvent>> {
        return this.smsEventGetWithHttpInfo(extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     */
    public userUserIdCampaignsCampaignIdDelete(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdDeleteWithHttpInfo(userId, campaignId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     */
    public userUserIdCampaignsCampaignIdGet(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<models.Campaign> {
        return this.userUserIdCampaignsCampaignIdGetWithHttpInfo(userId, campaignId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param campaign 
     */
    public userUserIdCampaignsCampaignIdPut(userId: string, campaignId: string, campaign: models.Campaign, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdPutWithHttpInfo(userId, campaignId, campaign, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId the id of the user
     * @param campaignId the id of the campaign
     */
    public userUserIdCampaignsCampaignIdQueueGet(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Array<models.QueueItem>> {
        return this.userUserIdCampaignsCampaignIdQueueGetWithHttpInfo(userId, campaignId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdDelete(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdDeleteWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDelete(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDeleteWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGet(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Array<models.CampaignEvent>> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGetWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPut(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPutWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdGet(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<models.QueueItem> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdGetWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queue Item in the campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDelete(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDeleteWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGet(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<models.CampaignQueueItemNotes> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGetWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queue item in the campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPut(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPutWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     * @param addOrUpdateQueueItem Add or Update a QueueItem in a Campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdPut(userId: string, campaignId: string, queueItemId: string, addOrUpdateQueueItem: models.QueueItem, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdPutWithHttpInfo(userId, campaignId, queueItemId, addOrUpdateQueueItem, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDelete(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDeleteWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGet(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<models.TaskStatus> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGetWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPut(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPutWithHttpInfo(userId, campaignId, queueItemId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of
     * @param campaignId The id of
     */
    public userUserIdCampaignsCampaignIdTaskListGet(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Array<models.CampaignTaskList>> {
        return this.userUserIdCampaignsCampaignIdTaskListGetWithHttpInfo(userId, campaignId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of
     * @param campaignId The id of
     * @param taskListId The id of
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdDelete(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdTaskListTaskListIdDeleteWithHttpInfo(userId, campaignId, taskListId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param taskListId The id of the TaskListItem
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdGet(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<models.TaskListItem> {
        return this.userUserIdCampaignsCampaignIdTaskListTaskListIdGetWithHttpInfo(userId, campaignId, taskListId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param taskListId The id of the task list item
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdPut(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.userUserIdCampaignsCampaignIdTaskListTaskListIdPutWithHttpInfo(userId, campaignId, taskListId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param userId The id of the user
     */
    public userUserIdCampaignsGet(userId: string, extraHttpRequestParams?: any): Observable<Array<models.Campaign>> {
        return this.userUserIdCampaignsGetWithHttpInfo(userId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdAuditReportGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/audit-report`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdAuditReportGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the association between a customer and a contact
     */
    public customerCustomerIdContactsContactIdDeleteWithHttpInfo(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/contacts/${contactId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdContactsContactIdDelete.');
        }
        // verify required parameter 'contactId' is not null or undefined
        if (contactId === null || contactId === undefined) {
            throw new Error('Required parameter contactId was null or undefined when calling customerCustomerIdContactsContactIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the contactId
     */
    public customerCustomerIdContactsContactIdGetWithHttpInfo(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/contacts/${contactId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdContactsContactIdGet.');
        }
        // verify required parameter 'contactId' is not null or undefined
        if (contactId === null || contactId === undefined) {
            throw new Error('Required parameter contactId was null or undefined when calling customerCustomerIdContactsContactIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param contactId The id of the association between a contact and a customer
     */
    public customerCustomerIdContactsContactIdPutWithHttpInfo(customerId: string, contactId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/contacts/${contactId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdContactsContactIdPut.');
        }
        // verify required parameter 'contactId' is not null or undefined
        if (contactId === null || contactId === undefined) {
            throw new Error('Required parameter contactId was null or undefined when calling customerCustomerIdContactsContactIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of
     */
    public customerCustomerIdContactsGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/contacts`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdContactsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdEquityReportGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/equity-report`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdEquityReportGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdInsOtherReportGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/ins-other-report`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdInsOtherReportGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     */
    public customerCustomerIdLifetimeValueReportGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/lifetime-value-report`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdLifetimeValueReportGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of
     */
    public customerCustomerIdRelationshipsGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/relationships`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdRelationshipsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdDeleteWithHttpInfo(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/relationships/${relationshipId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdDelete.');
        }
        // verify required parameter 'relationshipId' is not null or undefined
        if (relationshipId === null || relationshipId === undefined) {
            throw new Error('Required parameter relationshipId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdGetWithHttpInfo(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/relationships/${relationshipId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdGet.');
        }
        // verify required parameter 'relationshipId' is not null or undefined
        if (relationshipId === null || relationshipId === undefined) {
            throw new Error('Required parameter relationshipId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId The id of the customer
     * @param relationshipId The id of the association between a customer and their relationship
     */
    public customerCustomerIdRelationshipsRelationshipIdPutWithHttpInfo(customerId: string, relationshipId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/relationships/${relationshipId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdPut.');
        }
        // verify required parameter 'relationshipId' is not null or undefined
        if (relationshipId === null || relationshipId === undefined) {
            throw new Error('Required parameter relationshipId was null or undefined when calling customerCustomerIdRelationshipsRelationshipIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign email event
     */
    public emailEventEventIdDeleteWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling emailEventEventIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId the id of the campaign email event
     */
    public emailEventEventIdGetWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling emailEventEventIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign email event
     */
    public emailEventEventIdPutWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling emailEventEventIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     */
    public emailEventGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-event`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     */
    public emailTemplatesGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-templates`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param templateId The id of the template
     */
    public emailTemplatesTemplateIdDeleteWithHttpInfo(templateId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-templates/${templateId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'templateId' is not null or undefined
        if (templateId === null || templateId === undefined) {
            throw new Error('Required parameter templateId was null or undefined when calling emailTemplatesTemplateIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param templateId The id of the email template
     */
    public emailTemplatesTemplateIdGetWithHttpInfo(templateId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-templates/${templateId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'templateId' is not null or undefined
        if (templateId === null || templateId === undefined) {
            throw new Error('Required parameter templateId was null or undefined when calling emailTemplatesTemplateIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param templateId The id of the template
     * @param template 
     */
    public emailTemplatesTemplateIdPutWithHttpInfo(templateId: string, template: models.EmailTemplate, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/email-templates/${templateId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'templateId' is not null or undefined
        if (templateId === null || templateId === undefined) {
            throw new Error('Required parameter templateId was null or undefined when calling emailTemplatesTemplateIdPut.');
        }
        // verify required parameter 'template' is not null or undefined
        if (template === null || template === undefined) {
            throw new Error('Required parameter template was null or undefined when calling emailTemplatesTemplateIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: template == null ? '' : JSON.stringify(template), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     */
    public eventGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/event`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     */
    public phoneCallEventGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdDeleteWithHttpInfo(phoneCallId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdGetWithHttpInfo(phoneCallId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdNotesDeleteWithHttpInfo(phoneCallId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdNotesDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdNotesGetWithHttpInfo(phoneCallId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdNotesGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     * @param phoneCallNotes 
     */
    public phoneCallEventPhoneCallIdNotesPutWithHttpInfo(phoneCallId: string, phoneCallNotes: models.PhoneCallNotes, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdNotesPut.');
        }
        // verify required parameter 'phoneCallNotes' is not null or undefined
        if (phoneCallNotes === null || phoneCallNotes === undefined) {
            throw new Error('Required parameter phoneCallNotes was null or undefined when calling phoneCallEventPhoneCallIdNotesPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: phoneCallNotes == null ? '' : JSON.stringify(phoneCallNotes), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param phoneCallId The id of the phone call
     */
    public phoneCallEventPhoneCallIdPutWithHttpInfo(phoneCallId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/phone-call-event/${phoneCallId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'phoneCallId' is not null or undefined
        if (phoneCallId === null || phoneCallId === undefined) {
            throw new Error('Required parameter phoneCallId was null or undefined when calling phoneCallEventPhoneCallIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the sales appointment event
     */
    public salesAppointmentEventEventIdGetWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/sales-appointment-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling salesAppointmentEventEventIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdDeleteWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/sms-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling smsEventEventIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdGetWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/sms-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling smsEventEventIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param eventId The id of the campaign sms event
     */
    public smsEventEventIdPutWithHttpInfo(eventId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/sms-event/${eventId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'eventId' is not null or undefined
        if (eventId === null || eventId === undefined) {
            throw new Error('Required parameter eventId was null or undefined when calling smsEventEventIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     */
    public smsEventGetWithHttpInfo(extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/sms-event`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     */
    public userUserIdCampaignsCampaignIdDeleteWithHttpInfo(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     */
    public userUserIdCampaignsCampaignIdGetWithHttpInfo(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param campaign 
     */
    public userUserIdCampaignsCampaignIdPutWithHttpInfo(userId: string, campaignId: string, campaign: models.Campaign, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdPut.');
        }
        // verify required parameter 'campaign' is not null or undefined
        if (campaign === null || campaign === undefined) {
            throw new Error('Required parameter campaign was null or undefined when calling userUserIdCampaignsCampaignIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: campaign == null ? '' : JSON.stringify(campaign), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId the id of the user
     * @param campaignId the id of the campaign
     */
    public userUserIdCampaignsCampaignIdQueueGetWithHttpInfo(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdDeleteWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdDelete.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDeleteWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/events`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDelete.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGetWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/events`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGet.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPutWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/events`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPut.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdEventsPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdGetWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdGet.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queue Item in the campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDeleteWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDelete.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queueItem
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGetWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGet.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param queueItemId The id of the queue item in the campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPutWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/notes`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPut.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdNotesPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     * @param addOrUpdateQueueItem Add or Update a QueueItem in a Campaign
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdPutWithHttpInfo(userId: string, campaignId: string, queueItemId: string, addOrUpdateQueueItem: models.QueueItem, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdPut.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdPut.');
        }
        // verify required parameter 'addOrUpdateQueueItem' is not null or undefined
        if (addOrUpdateQueueItem === null || addOrUpdateQueueItem === undefined) {
            throw new Error('Required parameter addOrUpdateQueueItem was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: addOrUpdateQueueItem == null ? '' : JSON.stringify(addOrUpdateQueueItem), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDeleteWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/taskStatus`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDelete.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGetWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/taskStatus`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGet.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of campaign
     * @param queueItemId The id of the queueItem (the association between a customer lead and a campaign)
     */
    public userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPutWithHttpInfo(userId: string, campaignId: string, queueItemId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/queue/${queueItemId}/taskStatus`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPut.');
        }
        // verify required parameter 'queueItemId' is not null or undefined
        if (queueItemId === null || queueItemId === undefined) {
            throw new Error('Required parameter queueItemId was null or undefined when calling userUserIdCampaignsCampaignIdQueueQueueItemIdTaskStatusPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of
     * @param campaignId The id of
     */
    public userUserIdCampaignsCampaignIdTaskListGetWithHttpInfo(userId: string, campaignId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/taskList`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of
     * @param campaignId The id of
     * @param taskListId The id of
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdDeleteWithHttpInfo(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/taskList/${taskListId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdDelete.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdDelete.');
        }
        // verify required parameter 'taskListId' is not null or undefined
        if (taskListId === null || taskListId === undefined) {
            throw new Error('Required parameter taskListId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param taskListId The id of the TaskListItem
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdGetWithHttpInfo(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/taskList/${taskListId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdGet.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdGet.');
        }
        // verify required parameter 'taskListId' is not null or undefined
        if (taskListId === null || taskListId === undefined) {
            throw new Error('Required parameter taskListId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     * @param campaignId The id of the campaign
     * @param taskListId The id of the task list item
     */
    public userUserIdCampaignsCampaignIdTaskListTaskListIdPutWithHttpInfo(userId: string, campaignId: string, taskListId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns/${campaignId}/taskList/${taskListId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdPut.');
        }
        // verify required parameter 'campaignId' is not null or undefined
        if (campaignId === null || campaignId === undefined) {
            throw new Error('Required parameter campaignId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdPut.');
        }
        // verify required parameter 'taskListId' is not null or undefined
        if (taskListId === null || taskListId === undefined) {
            throw new Error('Required parameter taskListId was null or undefined when calling userUserIdCampaignsCampaignIdTaskListTaskListIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param userId The id of the user
     */
    public userUserIdCampaignsGetWithHttpInfo(userId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/user/${userId}/campaigns`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'userId' is not null or undefined
        if (userId === null || userId === undefined) {
            throw new Error('Required parameter userId was null or undefined when calling userUserIdCampaignsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
