/**
 * FutureDMS API
 * Premier Enterprise Dealership Management System
 *
 * OpenAPI spec version: 0.7.8
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class CustomerApi {
    protected basePath = 'https://api.futuredms.com/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * Gets a customer
     * The service ticket allows appointments and jobs related to a vehicle to be tracked 
     * @param customerId the id of a service ticket.
     */
    public customerCustomerIdGet(customerId: string, extraHttpRequestParams?: any): Observable<models.Customer> {
        return this.customerCustomerIdGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId 
     */
    public customerCustomerIdOpportunityGet(customerId: string, extraHttpRequestParams?: any): Observable<Array<models.Opportunity>> {
        return this.customerCustomerIdOpportunityGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Places or replaces a service ticket at the given id
     * Adds a service ticket for a given id  
     * @param customerId the id of a service ticket
     */
    public customerCustomerIdPut(customerId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdPutWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * A Customer&#39;s service-tickets
     * 
     * @param customerId the id of a customer
     */
    public customerCustomerIdServiceTicketsGet(customerId: string, extraHttpRequestParams?: any): Observable<Array<models.ServiceTicket>> {
        return this.customerCustomerIdServiceTicketsGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdDelete(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdVehicleCustomerVehicleIdDeleteWithHttpInfo(customerId, customerVehicleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdGet(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<models.VehicleDetail> {
        return this.customerCustomerIdVehicleCustomerVehicleIdGetWithHttpInfo(customerId, customerVehicleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     * @param vehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdPut(customerId: string, customerVehicleId: string, vehicleId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdVehicleCustomerVehicleIdPutWithHttpInfo(customerId, customerVehicleId, vehicleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * A Customer&#39;s vehicles
     * 
     * @param customerId the id of a customer
     */
    public customerCustomerIdVehicleGet(customerId: string, extraHttpRequestParams?: any): Observable<Array<models.Vehicle>> {
        return this.customerCustomerIdVehicleGetWithHttpInfo(customerId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * a service ticket tracks the activities between a customer, the service department.
     * A service ticket endpoint returns service tickets related to the logged in user 
     * @param page Pagination, Filtering, and Sorting information
     */
    public customerGet(page?: models.Page, extraHttpRequestParams?: any): Observable<Array<models.Customer>> {
        return this.customerGetWithHttpInfo(page, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param page Pagination, Filtering, and Sorting information
     */
    public paymentsGet(page?: models.Page, extraHttpRequestParams?: any): Observable<Array<models.Payment>> {
        return this.paymentsGetWithHttpInfo(page, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * A payment
     * 
     * @param paymentId the id of a payment
     */
    public paymentsPaymentIdGet(paymentId: string, extraHttpRequestParams?: any): Observable<models.PaymentDetail> {
        return this.paymentsPaymentIdGetWithHttpInfo(paymentId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param page Pagination, Filtering, and Sorting information
     */
    public visitsGet(page?: models.Page, extraHttpRequestParams?: any): Observable<Array<models.Visit>> {
        return this.visitsGetWithHttpInfo(page, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Gets a customer
     * The service ticket allows appointments and jobs related to a vehicle to be tracked 
     * @param customerId the id of a service ticket.
     */
    public customerCustomerIdGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId 
     */
    public customerCustomerIdOpportunityGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/opportunity`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdOpportunityGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Places or replaces a service ticket at the given id
     * Adds a service ticket for a given id  
     * @param customerId the id of a service ticket
     */
    public customerCustomerIdPutWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * A Customer&#39;s service-tickets
     * 
     * @param customerId the id of a customer
     */
    public customerCustomerIdServiceTicketsGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/service-tickets`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdServiceTicketsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdDeleteWithHttpInfo(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/vehicle/${customerVehicleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdDelete.');
        }
        // verify required parameter 'customerVehicleId' is not null or undefined
        if (customerVehicleId === null || customerVehicleId === undefined) {
            throw new Error('Required parameter customerVehicleId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdGetWithHttpInfo(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/vehicle/${customerVehicleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdGet.');
        }
        // verify required parameter 'customerVehicleId' is not null or undefined
        if (customerVehicleId === null || customerVehicleId === undefined) {
            throw new Error('Required parameter customerVehicleId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param customerId 
     * @param customerVehicleId 
     * @param vehicleId 
     */
    public customerCustomerIdVehicleCustomerVehicleIdPutWithHttpInfo(customerId: string, customerVehicleId: string, vehicleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/vehicle/${customerVehicleId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdPut.');
        }
        // verify required parameter 'customerVehicleId' is not null or undefined
        if (customerVehicleId === null || customerVehicleId === undefined) {
            throw new Error('Required parameter customerVehicleId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdPut.');
        }
        // verify required parameter 'vehicleId' is not null or undefined
        if (vehicleId === null || vehicleId === undefined) {
            throw new Error('Required parameter vehicleId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdPut.');
        }
        if (vehicleId !== undefined) {
            if(vehicleId instanceof Date) {
                queryParameters.set('vehicleId', <any>vehicleId.d.toISOString());
            } else {
                queryParameters.set('vehicleId', <any>vehicleId);
            }
        }

        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * A Customer&#39;s vehicles
     * 
     * @param customerId the id of a customer
     */
    public customerCustomerIdVehicleGetWithHttpInfo(customerId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/vehicle`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdVehicleGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * a service ticket tracks the activities between a customer, the service department.
     * A service ticket endpoint returns service tickets related to the logged in user 
     * @param page Pagination, Filtering, and Sorting information
     */
    public customerGetWithHttpInfo(page?: models.Page, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            body: page == null ? '' : JSON.stringify(page), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param page Pagination, Filtering, and Sorting information
     */
    public paymentsGetWithHttpInfo(page?: models.Page, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/payments`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            body: page == null ? '' : JSON.stringify(page), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * A payment
     * 
     * @param paymentId the id of a payment
     */
    public paymentsPaymentIdGetWithHttpInfo(paymentId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/payments/${paymentId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'paymentId' is not null or undefined
        if (paymentId === null || paymentId === undefined) {
            throw new Error('Required parameter paymentId was null or undefined when calling paymentsPaymentIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param page Pagination, Filtering, and Sorting information
     */
    public visitsGetWithHttpInfo(page?: models.Page, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/visits`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            body: page == null ? '' : JSON.stringify(page), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
