import { Component, Input, Output, EventEmitter } from '@angular/core';
import { MdDialog } from '@angular/material';
import { Router } from '@angular/router';
var CardComponent = (function () {
    function CardComponent(router, dialog) {
        this.router = router;
        this.dialog = dialog;
        this.bgcolor = "red";
        this.click_card = new EventEmitter();
    }
    CardComponent.prototype.ngOnInit = function () {
    };
    CardComponent.prototype.showDetail = function () {
        // let dialogRef: MdDialogRef<CardDetailDialogComponent>;
        // dialogRef = this.dialog.open(CardDetailDialogComponent, {
        //   height: '80%',
        //   width: '85%'
        // });
        // dialogRef.afterClosed().subscribe(result => {
        //   console.log('Dialog Result: ${result}');
        // });        
        this.click_card.emit(this.card_data);
    };
    CardComponent.prototype.getProperString = function (source) {
        if (source.length > 20) {
            return source.substr(0, 20) + "...";
        }
        else {
            return source;
        }
    };
    return CardComponent;
}());
export { CardComponent };
CardComponent.decorators = [
    { type: Component, args: [{
                selector: 'card',
                template: "\n    <div class=\"card\">\n      <md-card>\n        <md-card-content>\n          <div>\n            <p>\n              {{ getProperString(card_data.description) }}\n            </p>\n          </div>\n          <div>\n            <span class=\"ticket-num\"> \n              #{{ card_data.card_no }}\n            </span>\n            <span class=\"due-date\">\n              {{ card_data.due_date }}\n            </span> \n          </div>\n        </md-card-content>\n        <md-card-actions>\n          <a (click)=\"showDetail()\">\n            <md-icon>star</md-icon>\n          </a>\n          <a (click)=\"showDetail()\">\n            <md-icon>home</md-icon>\n          </a>\n        </md-card-actions>\n      </md-card>\n    </div>\n  ",
                styles: ["\n    .card{width:100%;margin:5px 0}.card md-icon{font-size:20px}.card md-card-actions{text-align:right}.card md-card-content{margin-bottom:0}.card md-card-content .due-date{color:red}\n  "]
            },] },
];
/** @nocollapse */
CardComponent.ctorParameters = function () { return [
    { type: Router, },
    { type: MdDialog, },
]; };
CardComponent.propDecorators = {
    'bgcolor': [{ type: Input },],
    'card_data': [{ type: Input },],
    'click_card': [{ type: Output },],
};
//# sourceMappingURL=card.component.js.map