import { OnInit, EventEmitter, AfterViewInit } from '@angular/core';
import { MdDialog } from '@angular/material';
import { Router } from '@angular/router';
import { DragulaService } from 'ng2-dragula/ng2-dragula';
import { DataClassificationInterface } from '../interface/data_classification.interface';
export declare class DataClassificationComponent implements OnInit, AfterViewInit {
    private router;
    private dragulaService;
    private dialog;
    private data_classification_service;
    nodes: Array<any>;
    private header;
    private footer;
    private options_for_tree;
    private isOneToMany;
    private isHierarchical;
    private is_new_parent_available;
    private is_new_child_available;
    private parent;
    private parent_description;
    private child;
    private child_description;
    private parents;
    click_card: EventEmitter<{}>;
    private job_title;
    private job_description;
    private job_categories;
    private selected_category_for_job;
    private current_job;
    private search_text;
    private advanced_search_text;
    private current_item;
    constructor(router: Router, dragulaService: DragulaService, dialog: MdDialog, data_classification_service: DataClassificationInterface);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    getDurationDays(date1: any, date2: any): number;
    private hasClass(el, name);
    private addClass(el, name);
    private removeClass(el, name);
    advancedSearch(): void;
    doAdvancedSearch(): void;
    _click_card(card_data: any): void;
    onVisibleContainer(status: any): void;
    isCollapsible(status: any): boolean;
    addCategoryForJob(): void;
    removeCategoryForJob(category: any): void;
    newChildModal(): void;
    newParentModal(): void;
    getParents(parents: any): void;
    getCurrentItem(): {
        id: any;
        title: any;
        description: string;
        due_to: string;
    };
    onChangeNode(event: any): void;
    onSelectItem(node: any): void;
}
