var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, Output, EventEmitter } from '@angular/core';
import { Router } from '@angular/router';
import { DragulaService } from 'ng2-dragula/ng2-dragula';
import { CardwallComponent } from './cardwall.component';
var ServiceRouterCardwallComponent = (function (_super) {
    __extends(ServiceRouterCardwallComponent, _super);
    function ServiceRouterCardwallComponent(service_router, service_dragulaService, service_router_cardwall_interface) {
        var _this = _super.call(this, service_router, service_dragulaService, service_router_cardwall_interface) || this;
        _this.service_router = service_router;
        _this.service_dragulaService = service_dragulaService;
        _this.service_router_cardwall_interface = service_router_cardwall_interface;
        _this.service_router_cardwall_data = [];
        _this.card_click_event = new EventEmitter();
        for (var _i = 0, _a = _this.getCardwallData(); _i < _a.length; _i++) {
            var container = _a[_i];
            if (_this.isVisible(container.name)) {
                _this.service_router_cardwall_data.push(container);
            }
        }
        return _this;
    }
    ServiceRouterCardwallComponent.prototype.isVisible = function (cardwall_name) {
        switch (cardwall_name) {
            case 'predispatch':
                return this.service_router_cardwall_interface.canPredispatchTicket();
            case 'dispatch':
                return this.service_router_cardwall_interface.canDispatchTicket();
            case 'parts_request':
                return this.service_router_cardwall_interface.canPriceParts();
            case 'class_a':
                return this.service_router_cardwall_interface.canReassignTechnician();
            case 'class_b':
                return this.service_router_cardwall_interface.canReassignTechnician();
            case 'class_c':
                return this.service_router_cardwall_interface.canReassignTechnician();
            case 'technician_queue':
                return this.service_router_cardwall_interface.canViewTechnicianQueue();
            case 'inspection_queue':
                return this.service_router_cardwall_interface.canViewInspections();
            case 'in_progress_queue':
                return this.service_router_cardwall_interface.canViewServiceTicketJobsInProcess();
            case 'additional_approvals':
                return this.service_router_cardwall_interface.canHandleApprovals();
            case 'completed_queue':
                return this.service_router_cardwall_interface.canViewServiceTicketComplete();
            case 'invoice':
                return this.service_router_cardwall_interface.canHandleInvoice();
            case 'closed_queue':
                return this.service_router_cardwall_interface.canViewClose();
            default:
                return false;
        }
    };
    ServiceRouterCardwallComponent.prototype.getServiceRouterCardwallData = function () {
        return this.service_router_cardwall_data;
    };
    ServiceRouterCardwallComponent.prototype.__click_card = function (card_data, status) {
        this.card_click_event.emit(card_data);
    };
    return ServiceRouterCardwallComponent;
}(CardwallComponent));
export { ServiceRouterCardwallComponent };
ServiceRouterCardwallComponent.decorators = [
    { type: Component, args: [{
                selector: 'service-router-cardwall',
                template: "\n    <div class=\"row\">\n    \t<div class='wrapper row cardwall-wrapper'>\n    \t  <div class='cardwall-container' *ngFor=\"let container of getServiceRouterCardwallData(); let status=index;\">\n    \t  \t<div class=\"cardwall\">\n    \t\t  \t<h5> {{ container.name }}</h5>\n    \t\t  \t<h6> {{ container.cards.length }} </h6>\n    \t\t  \t<div class=\"cardwall-cards\" [dragula]='\"nested-bag\"' [id]=\"status\" [dragulaModel]=\"container.cards\">\n    \t\t\t    <div *ngFor='let card of container.cards'>\n    \t\t\t    \t<card [card_data]=\"card\" (click_card)=\"__click_card($event, status)\"></card>\n    \t\t\t    </div>\n    \t\t\t  </div>  \n    \t\t\t</div>\n    \t  </div>\n    \t</div>\n    </div>\n  ",
                styles: ["\n    .gu-mirror{position:fixed!important;margin:0!important;z-index:9999!important;opacity:.8;-ms-filter:\"progid:DXImageTransform.Microsoft.Alpha(Opacity=80)\";filter:alpha(opacity=80)}.gu-hide{display:none!important}.gu-unselectable{-webkit-user-select:none!important;-moz-user-select:none!important;-ms-user-select:none!important;user-select:none!important}.gu-transit{opacity:.2;-ms-filter:\"progid:DXImageTransform.Microsoft.Alpha(Opacity=20)\";filter:alpha(opacity=20)}.wrapper.row{display:flex}.cardwall-wrapper{width:100%;overflow-y:hidden;overflow-x:auto}.cardwall-wrapper .cardwall{height:100%;padding:0 10px 10px;border:1px solid #e9f0f1;margin:10px 0;background-color:#e9f0f1;border-radius:4px;color:#000}.cardwall-wrapper .cardwall .cardwall-cards{min-height:180px}.cardwall-wrapper .cardwall .cardwall-cards .card{margin:5px 0}.cardwall-wrapper .cardwall-container{width:23%;margin:10px 1%;min-width:185px}.cardwall-wrapper .col.s3{margin-left:initial}.advanced-search-btn{margin-top:10px}\n  "]
            },] },
];
/** @nocollapse */
ServiceRouterCardwallComponent.ctorParameters = function () { return [
    { type: Router, },
    { type: DragulaService, },
    { type: undefined, decorators: [{ type: Inject, args: ['ServiceRouterCardwallInterface',] },] },
]; };
ServiceRouterCardwallComponent.propDecorators = {
    'card_click_event': [{ type: Output },],
};
//# sourceMappingURL=service_router_cardwall.component.js.map