import { ModuleWithProviders, NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { RouterModule } from '@angular/router';
import { DragulaModule } from 'ng2-dragula';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import 'hammerjs';
// import { CalendarModule } from 'ap-angular2-fullcalendar';
import {MomentModule} from 'angular2-moment/moment.module';
// import { SharedLibrary } from 'shared_library';
import { SharedLibrary } from '../../components_src'
// Wizard Process
import { FormWizardModule } from 'angular2-wizard';
//Components
import { HomeLayoutComponent, HomeComponent } from './home';
// import { CardComponent, DataClassificationComponent } from '../../../src'
//Shared Library Components
//Import Routes
import { HomeRoutes } from './home' 

import { AppComponent } from './app.component';
import { 
  SidebarComponent,
} from './shared';

import { AppRoutingModule } from './app.routing';

//services
import { JobClassificationService } from './services/job_classification.service';
import { UserRolesService } from './services/user_roles.service';
import { ServiceRouterService } from './services/service_router.service';

@NgModule({
  declarations: [
    AppComponent,    
    //LayoutComponent
    // SidebarComponent,
    //Home Components
    HomeLayoutComponent,
    HomeComponent,
    //Data Classification Component
    // CardComponent,
    // DataClassificationComponent
  ],
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    CommonModule,
    AppRoutingModule,
    DragulaModule,
    FormWizardModule,    
    FormsModule,
    //FullCalendar Module
    // CalendarModule,  
    //Moment Module
    MomentModule,
    // Shared Library
    SharedLibrary
  ],
  providers: [
    JobClassificationService,
    UserRolesService,
    ServiceRouterService
  ],
  bootstrap: [AppComponent]
})
export class AppModule {}
