import { Injectable } from '@angular/core';
import { DataClassificationInterface } from '../../../components_src'

@Injectable()
export class JobClassificationService implements DataClassificationInterface{
  getData() {
    let job_classification : Array<any> = [
      {
        id: 1,
        name: 'class1',
        children: [
          { id: 2, name: 'job1' },
          { id: 3, name: 'job2' }
        ]
      },
      {
        id: 4,
        name: 'class2',
        children: [
          { id: 5, name: 'job2.1' },
          {
            id: 6,
            name: 'class2.2',
            children: [
              { id: 7, name: 'job2.2.1' }
            ]
          }
        ]
      }
    ]
    return job_classification;
  }

  getParentFields() {
  	return ["title", "description"];
  }

  addNewParent() {

  }

  updateParent() {

  }

  removeParent() {

  }

  getChildFields() {
  	return ["title", "description", "child_order"];
  }

  addNewChild() {

  }

  updateChild() {

  }

  removeChild() {

  }

  isOneToMany() {
  	return false;
  }
  isHierarchical() {
  	return false;
  }

  getLabels() {
    return {
      "parent": {
        "label": "classification",
        "description": "Please fill in the form"
      },
      "child": {
        "label": "job",
        "description": "Please fill in the form"
      }
    };
  }

  getHeader() {
    return "Job Classification";
  }

  getFooter() {
    return "You can create any job and Classification, move any job to any classification.";
  }

  isNewParentAvailable() {
    return true;
  }

  isNewChildAvailable() {
    return true;
  }
}