import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { MdDialogRef, MdDialog, MdDialogConfig } from '@angular/material';
import { Router } from '@angular/router';
import { CardDetailDialogComponent } from './index';
declare var $;

@Component({
  selector: 'card',
  template: `
    <div class="card">
      <md-card>
        <md-card-content>
          <div>
            <p>
              {{ getProperString(card_data.description) }}
            </p>
          </div>
          <div>
            <span class="ticket-num"> 
              #{{ card_data.card_no }}
            </span>
            <span class="due-date">
              {{ card_data.due_date }}
            </span> 
          </div>
        </md-card-content>
        <md-card-actions>
          <a (click)="showDetail()">
            <md-icon>star</md-icon>
          </a>
          <a (click)="showDetail()">
            <md-icon>home</md-icon>
          </a>
        </md-card-actions>
      </md-card>
    </div>
  `,
  styles: [`
    .card{width:100%;margin:5px 0}.card md-icon{font-size:20px}.card md-card-actions{text-align:right}.card md-card-content{margin-bottom:0}.card md-card-content .due-date{color:red}
  `]
})
export class CardComponent implements OnInit {
  @Input() bgcolor:string = "red";
  @Input() card_data: any;
  @Output() click_card = new EventEmitter();

  constructor(
    private router: Router,
    private dialog: MdDialog,
  ) {}

  ngOnInit() {
  }
  showDetail() {
    // let dialogRef: MdDialogRef<CardDetailDialogComponent>;
    // dialogRef = this.dialog.open(CardDetailDialogComponent, {
    //   height: '80%',
    //   width: '85%'
    // });
    // dialogRef.afterClosed().subscribe(result => {
    //   console.log('Dialog Result: ${result}');
    // });        
    this.click_card.emit(this.card_data);
  }
  
  getProperString(source) {
    if (source.length > 20) {
      return source.substr(0, 20) + "..."
    } 
    else {
      return source
    }
  }  
}

