import { MdDialogRef } from '@angular/material';
import { Component, OnInit, Input, Output, EventEmitter, ElementRef, ViewChild } from '@angular/core';
declare var $;

@Component({
    selector: 'new-child-dialog',
    template: `
      <h2 md-dialog-title>Add {{ child }}</h2>
      <p> {{ child_description }}</p>
      <md-dialog-content>
        <div class="row" *ngFor="let field of fields_for_child;">
          <div class="input-field col-sm-12">
            <md-input-container class="field-wrapper">
              <input mdInput placeholder="{{ field }}">
            </md-input-container>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12" *ngIf="!isOneToMany">
            <select multiple="multiple" class="multi-select" name="my-select[]">
                <option *ngFor="let group of items" [value]="group.group_name" [disabled]="isDisabled(item)">{{group.group_name }}</option>
            </select>          
          </div>        
          <md-select placeholder="Parent" class="col-sm-12"  *ngIf="isOneToMany">
             <md-option *ngFor="let group of items" [value]="group.group_name">{{ group.group_name }}</md-option>
          </md-select>
        </div>      
      </md-dialog-content>
      <md-dialog-actions>
      	<button md-button md-dialog-close>Add</button>
      	<button md-button md-dialog-close>Cancel</button>
      </md-dialog-actions>
    `,
    styles: [`
      .row{margin-bottom:20px}.field-wrapper{width:100%}.mat-dialog-actions{float:right}
    `]
})
export class NewChildDialogComponent implements OnInit{
  public fields_for_child: Array<any> = [
    "title",
    "description"
  ];

  public isOneToMany : boolean = true;
  public child : string = "child";
  public child_description : string = "Please fill in the form";
  @ViewChild("group_selector") group_selector: any;
  @ViewChild("items_selector") items_selector: any;

  private groups = [
    {
      label: 'role1',
      description: "adfadsfzcnm kaf akasjf asz sdv",
      parent: '',
      items: ["read", "write"]
    }
  ];
  private items = [
    {
      group_name: "group1",
      items: [
        {
          name: "item1",
          property: "read",
        },
        {
          name: "item2",
          property: "write",
        },
        {
          name: "item3",
          property: "update",
        },
      ],
    },  
    {
      group_name: "group2",
      items: [
        {
          name: "item4",
          property: "a",
        },
        {
          name: "item5",
          property: "b",
        },
        {
          name: "item6",
          property: "c",
        },
      ],
    },  
    {
      group_name: "group3",
      items: [
        {
          name: "item7",
          property: "d",
        },
        {
          name: "item8",
          property: "e",
        },
        {
          name: "item9",
          property: "f",
        },
      ],
    },  
  ];

  public title: string;
  public message: string;


  private label : string;
  private description : string;
  private disabled_items: any = [];

  constructor(public dialogRef: MdDialogRef<NewChildDialogComponent>) {

  }

  ngOnInit() {

  }

  ngAfterViewInit() {
  	$('.multi-select').multiSelect();
  }

  isDisabled(item) {
  	return false;
  }
}