import { MdDialogRef } from '@angular/material';
import { Component, Inject, OnInit, Input, Output, EventEmitter, ElementRef, ViewChild } from '@angular/core';
import { DataClassificationInterface } from '../interface/data_classification.interface';
declare var $;

@Component({
    selector: 'new-parent-dialog',
    template: `
      <h2 md-dialog-title>Add {{ parent }}</h2>
      <p> {{ parent_description }}</p>
      <md-dialog-content>
        <div class="row" *ngFor="let field of fields_for_parent;">
          <div class="input-field col-sm-12">
            <md-input-container class="field-wrapper">
            	<input mdInput placeholder="{{ field }}">
            </md-input-container>
          </div>
        </div>
        <div class="row">
          <div class="input-field col-sm-12">
      			<md-select placeholder="Parent" class="field-wrapper">
      				<md-option>None</md-option>
      			  <md-option *ngFor="let group of groups" [value]="group.label">{{ group.label }}</md-option>
      			</md-select>    	
          </div>      
        </div>
        <div class="row">
          <div class="col-sm-12">
            <select multiple="multiple" class="multi-select" name="my-select[]">
              <optgroup *ngFor="let group of items" label="{{group.group_name}}">
                <option *ngFor="let item of group.items" [value]="item.property" [disabled]="isDisabled(item)">{{item.property}}</option>
              </optgroup>
            </select>          
          </div>        
        </div>      
      </md-dialog-content>
      <md-dialog-actions>
      	<button md-button md-dialog-close>Add</button>
      	<button md-button md-dialog-close>Cancel</button>
      </md-dialog-actions>
    `,
    styles: [`
      .row{margin-bottom:20px}.field-wrapper{width:100%}.mat-dialog-actions{float:right}
    `],
    providers: [
    ]
})
export class NewParentDialogComponent implements OnInit{
	public fields_for_parent: Array<any> = [
		"title",
		"description"
	];

  public parent = "parent";
  public parent_description : string = "Please fill in the form";
  @ViewChild("group_selector") group_selector: any;
  @ViewChild("items_selector") items_selector: any;

  private groups = [
    {
      label: 'role1',
      description: "adfadsfzcnm kaf akasjf asz sdv",
      parent: '',
      items: ["read", "write"]
    }
  ];
  private items = [
    {
      group_name: "group1",
      items: [
        {
          name: "item1",
          property: "read",
        },
        {
          name: "item2",
          property: "write",
        },
        {
          name: "item3",
          property: "update",
        },
      ],
    },  
    {
      group_name: "group2",
      items: [
        {
          name: "item4",
          property: "a",
        },
        {
          name: "item5",
          property: "b",
        },
        {
          name: "item6",
          property: "c",
        },
      ],
    },  
    {
      group_name: "group3",
      items: [
        {
          name: "item7",
          property: "d",
        },
        {
          name: "item8",
          property: "e",
        },
        {
          name: "item9",
          property: "f",
        },
      ],
    },  
  ];

  public title: string;
  public message: string;


  private label : string;
  private description : string;
  private disabled_items: any = [];

  constructor(public dialogRef: MdDialogRef<NewParentDialogComponent>) {

  }

  ngOnInit() {

  }

  ngAfterViewInit() {
  	$('.multi-select').multiSelect();
  }

  isDisabled(item) {
  	return false;
  }
}