/**
 * FutureDMS API
 * Premier Enterprise Dealership Management System
 *
 * OpenAPI spec version: 0.7.8
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import { Inject, Injectable, Optional }                      from '@angular/core';
import { Http, Headers, URLSearchParams }                    from '@angular/http';
import { RequestMethod, RequestOptions, RequestOptionsArgs } from '@angular/http';
import { Response, ResponseContentType }                     from '@angular/http';

import { Observable }                                        from 'rxjs/Observable';
import 'rxjs/add/operator/map';

import * as models                                           from '../model/models';
import { BASE_PATH, COLLECTION_FORMATS }                     from '../variables';
import { Configuration }                                     from '../configuration';

/* tslint:disable:no-unused-variable member-ordering */


@Injectable()
export class DefaultApi {
    protected basePath = 'https://api.futuredms.com/v1';
    public defaultHeaders: Headers = new Headers();
    public configuration: Configuration = new Configuration();

    constructor(protected http: Http, @Optional()@Inject(BASE_PATH) basePath: string, @Optional() configuration: Configuration) {
        if (basePath) {
            this.basePath = basePath;
        }
        if (configuration) {
            this.configuration = configuration;
        }
    }

    /**
     * Update a vehicle&#39;s status
     * 
     * @param customerId the id of a customer
     * @param customerVehicleId the id of the association between a customer and a vehicle
     */
    public customerCustomerIdVehicleCustomerVehicleIdStatusPut(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.customerCustomerIdVehicleCustomerVehicleIdStatusPutWithHttpInfo(customerId, customerVehicleId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsGet(inspectionCriteriaId: string, extraHttpRequestParams?: any): Observable<Array<models.Job>> {
        return this.inspectionCriteriaInspectionCriteriaIdJobsGetWithHttpInfo(inspectionCriteriaId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdDelete(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdDeleteWithHttpInfo(inspectionCriteriaId, inspectionCriteriaJobAssociationId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdGet(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, extraHttpRequestParams?: any): Observable<models.Job> {
        return this.inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdGetWithHttpInfo(inspectionCriteriaId, inspectionCriteriaJobAssociationId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     * @param inspectionCriteriaJob The Inspection Criteria and Job Association
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdPut(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, inspectionCriteriaJob?: models.InspectionCriteriaJobAssociation, extraHttpRequestParams?: any): Observable<{}> {
        return this.inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdPutWithHttpInfo(inspectionCriteriaId, inspectionCriteriaJobAssociationId, inspectionCriteriaJob, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Adds data related to an appointment when the customer pull into the dealership
     * Add details when the customer arrives such as mileage, customer and advisor observations
     * @param serviceTicketId the id of a service ticket
     */
    public serviceTicketServiceTicketIdAppointmentPut(serviceTicketId: string, extraHttpRequestParams?: any): Observable<{}> {
        return this.serviceTicketServiceTicketIdAppointmentPutWithHttpInfo(serviceTicketId, extraHttpRequestParams)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }


    /**
     * Update a vehicle&#39;s status
     * 
     * @param customerId the id of a customer
     * @param customerVehicleId the id of the association between a customer and a vehicle
     */
    public customerCustomerIdVehicleCustomerVehicleIdStatusPutWithHttpInfo(customerId: string, customerVehicleId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/customer/${customerId}/vehicle/${customerVehicleId}/status`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'customerId' is not null or undefined
        if (customerId === null || customerId === undefined) {
            throw new Error('Required parameter customerId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdStatusPut.');
        }
        // verify required parameter 'customerVehicleId' is not null or undefined
        if (customerVehicleId === null || customerVehicleId === undefined) {
            throw new Error('Required parameter customerVehicleId was null or undefined when calling customerCustomerIdVehicleCustomerVehicleIdStatusPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsGetWithHttpInfo(inspectionCriteriaId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/inspection-criteria/${inspectionCriteriaId}/jobs`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'inspectionCriteriaId' is not null or undefined
        if (inspectionCriteriaId === null || inspectionCriteriaId === undefined) {
            throw new Error('Required parameter inspectionCriteriaId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdDeleteWithHttpInfo(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/inspection-criteria/${inspectionCriteriaId}/jobs/${inspectionCriteriaJobAssociationId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'inspectionCriteriaId' is not null or undefined
        if (inspectionCriteriaId === null || inspectionCriteriaId === undefined) {
            throw new Error('Required parameter inspectionCriteriaId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdDelete.');
        }
        // verify required parameter 'inspectionCriteriaJobAssociationId' is not null or undefined
        if (inspectionCriteriaJobAssociationId === null || inspectionCriteriaJobAssociationId === undefined) {
            throw new Error('Required parameter inspectionCriteriaJobAssociationId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdDelete.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Delete,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdGetWithHttpInfo(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/inspection-criteria/${inspectionCriteriaId}/jobs/${inspectionCriteriaJobAssociationId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'inspectionCriteriaId' is not null or undefined
        if (inspectionCriteriaId === null || inspectionCriteriaId === undefined) {
            throw new Error('Required parameter inspectionCriteriaId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdGet.');
        }
        // verify required parameter 'inspectionCriteriaJobAssociationId' is not null or undefined
        if (inspectionCriteriaJobAssociationId === null || inspectionCriteriaJobAssociationId === undefined) {
            throw new Error('Required parameter inspectionCriteriaJobAssociationId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdGet.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Get,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * 
     * 
     * @param inspectionCriteriaId 
     * @param inspectionCriteriaJobAssociationId 
     * @param inspectionCriteriaJob The Inspection Criteria and Job Association
     */
    public inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdPutWithHttpInfo(inspectionCriteriaId: string, inspectionCriteriaJobAssociationId: string, inspectionCriteriaJob?: models.InspectionCriteriaJobAssociation, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/inspection-criteria/${inspectionCriteriaId}/jobs/${inspectionCriteriaJobAssociationId}`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'inspectionCriteriaId' is not null or undefined
        if (inspectionCriteriaId === null || inspectionCriteriaId === undefined) {
            throw new Error('Required parameter inspectionCriteriaId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdPut.');
        }
        // verify required parameter 'inspectionCriteriaJobAssociationId' is not null or undefined
        if (inspectionCriteriaJobAssociationId === null || inspectionCriteriaJobAssociationId === undefined) {
            throw new Error('Required parameter inspectionCriteriaJobAssociationId was null or undefined when calling inspectionCriteriaInspectionCriteriaIdJobsInspectionCriteriaJobAssociationIdPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        headers.set('Content-Type', 'application/json');

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            body: inspectionCriteriaJob == null ? '' : JSON.stringify(inspectionCriteriaJob), // https://github.com/angular/angular/issues/10612
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

    /**
     * Adds data related to an appointment when the customer pull into the dealership
     * Add details when the customer arrives such as mileage, customer and advisor observations
     * @param serviceTicketId the id of a service ticket
     */
    public serviceTicketServiceTicketIdAppointmentPutWithHttpInfo(serviceTicketId: string, extraHttpRequestParams?: any): Observable<Response> {
        const path = this.basePath + `/service-ticket/${serviceTicketId}/appointment`;

        let queryParameters = new URLSearchParams();
        let headers = new Headers(this.defaultHeaders.toJSON()); // https://github.com/angular/angular/issues/6845
        // verify required parameter 'serviceTicketId' is not null or undefined
        if (serviceTicketId === null || serviceTicketId === undefined) {
            throw new Error('Required parameter serviceTicketId was null or undefined when calling serviceTicketServiceTicketIdAppointmentPut.');
        }
        // to determine the Content-Type header
        let consumes: string[] = [
        ];

        // to determine the Accept header
        let produces: string[] = [
            'application/json'
        ];

        let requestOptions: RequestOptionsArgs = new RequestOptions({
            method: RequestMethod.Put,
            headers: headers,
            search: queryParameters
        });

        // https://github.com/swagger-api/swagger-codegen/issues/4037
        if (extraHttpRequestParams) {
            requestOptions = (<any>Object).assign(requestOptions, extraHttpRequestParams);
        }

        return this.http.request(path, requestOptions);
    }

}
