import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { Subject } from 'rxjs/Subject';
import { BehaviorSubject }  from 'rxjs/BehaviorSubject';
import { WebsocketConnectionService } from './websocket_connection_service';
import { Observer } from 'rxjs/Observer';

export interface message {
    topic: string,
    event: string,
    payload: object
};

@Injectable()
export class NotificationEventsService {
    private topic_registry_list : any;

    constructor(private websocket_connection_service: WebsocketConnectionService) {
        const notification_url = 'ws://localhost:8080/chat';
        this.websocket_connection_service.connect(notification_url).subscribe((message) => {
            let topic : string = message.topic;
            this.topic_registry_list[topic].next(message);
        });

    }
 
    registerEvent(topic: string): Observable<any> {
        if (this.getSubject(topic)) {
            return this.getSubject(topic);
        }
        else {
           let new_behavior_subject = new BehaviorSubject<string>(null);
           this.topic_registry_list[topic] = new_behavior_subject;
           return new_behavior_subject;
        }
    }

    private getSubject(topic: string) {
        if (this.topic_registry_list[topic])
        {
            return this.topic_registry_list[topic]    
        }
        else {
            return null;
        }
    }
}