import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { TreeModule } from 'angular-tree-component';

import { FormsModule, ReactiveFormsModule } from '@angular/forms';

import { CardwallComponent, CardComponent, DataClassificationComponent, NewParentDialogComponent, NewChildDialogComponent, CardDetailDialogComponent, ServiceRouterCardwallComponent}   from './components';
import { DragulaModule } from 'ng2-dragula';

//angular materal components
import {
    MaterialModule, 
    MdButtonModule,
    MdInputModule,
} from '@angular/material'

@NgModule({
    imports: [
        CommonModule,
        FormsModule,
        ReactiveFormsModule,
        TreeModule,
        DragulaModule,
        MaterialModule,
        MdButtonModule,
        MdInputModule
    ],
    exports: [
        CardwallComponent,
        DataClassificationComponent,
        ServiceRouterCardwallComponent,
    ],
    declarations: [
        CardwallComponent,
        CardComponent,
        DataClassificationComponent,
        NewChildDialogComponent,
        NewParentDialogComponent,
        CardDetailDialogComponent,
        ServiceRouterCardwallComponent
    ],
    providers: [        
    ],
    entryComponents: [
        NewChildDialogComponent,
        NewParentDialogComponent,
        CardDetailDialogComponent
    ]
})
export class SharedLibrary { }
